image: docker:stable

stages:
    - build
    - test
    - deploy

services:
  - docker:dind

variables:
    TEST_FLD: Otus.Teaching.PromoCodeFactory.UnitTests

build:
  only:
    - master
  before_script:
    - docker login registry.gitlab.com -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD}
  script:
    - docker build -t ${CI_REGISTRY}/${CI_PROJECT_PATH}:latest src
    - docker push ${CI_REGISTRY}/${CI_PROJECT_PATH}:latest
  after_script:
    - docker logout ${CI_REGISTRY}
  stage: build
  tags: 
    - docker
        
test:
  image: mcr.microsoft.com/dotnet/core/sdk:3.1
  stage: test
  script:
    - dotnet test src/$TEST_FLD/$TEST_FLD.csproj
deploy:
    stage: deploy
    script:
      - echo "kubectl apply -f promocode-factory-api.yaml"
